// PeriodicTableDlg.cpp : implementation file
//
#include <afxdlgs.h>
#include "stdafx.h"
#include "PeriodicTable.h"
#include "PeriodicTableDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/* ********************************* */
/* MFC                               */
/* ********************************* */
CPeriodicTableDlg::CPeriodicTableDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPeriodicTableDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPeriodicTableDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPeriodicTableDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPeriodicTableDlg)
	DDX_Control(pDX, IDSTATIC_SETINGSFRAME, m_SettingsFrame);
	DDX_Control(pDX, IDSTATIC_DRAGSLIDERS,  m_DragSliders);
	DDX_Control(pDX, IDSTATIC_RVALUE,       m_RValue);
	DDX_Control(pDX, IDSTATIC_GVALUE,		m_GValue);
	DDX_Control(pDX, IDSTATIC_BVALUE,		m_BValue);
	DDX_Control(pDX, IDS_RED,				m_SliderRed);
	DDX_Control(pDX, IDS_GREEN,				m_SliderGreen);
	DDX_Control(pDX, IDS_BLUE,				m_SliderBlue);
	DDX_Control(pDX, IDSTATIC_R,            m_R);
	DDX_Control(pDX, IDSTATIC_G,			m_G);
	DDX_Control(pDX, IDSTATIC_B,			m_B);
	DDX_Control(pDX, IDSTATIC_SELECTGROUP , m_SelectGroup);
	DDX_Control(pDX, IDC_GROUPS,			m_GroupList);
	DDX_Control(pDX, IDBN_SETFONT,			m_SetFont);
	DDX_Control(pDX, IDC_ELEMENTLIST,		m_ElementList);
	DDX_Control(pDX, IDC_CLEARLIST,			m_ClearButton);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPeriodicTableDlg, CDialog)
	//{{AFX_MSG_MAP(CPeriodicTableDlg)
	ON_CBN_SELCHANGE(IDC_GROUPS, OnSelchangeGroupList)
	ON_BN_CLICKED(IDC_CLEARLIST, OnClearList)
	ON_BN_CLICKED(IDBN_SETFONT, OnSetFont)
	ON_WM_PAINT()
	ON_WM_HSCROLL()
	ON_WM_QUERYDRAGICON()
	ON_WM_LBUTTONDBLCLK()
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_WM_RBUTTONDOWN()
	ON_WM_SIZE()
	ON_WM_SIZING()
	ON_WM_GETMINMAXINFO()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/* ********************************* */
/* Dialog initialization             */
/* ********************************* */
BOOL CPeriodicTableDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);
	
	// Initialize the main pteTable object
	Table.InitGroups();
	Table.InitElements();

	// initialize the color change slider controls
	m_SliderRed.SetRange  (0, 255, TRUE);
	m_SliderGreen.SetRange(0, 255, TRUE);
	m_SliderBlue.SetRange (0, 255, TRUE);

	// select the first item in the groups listbox
	m_GroupList.SetCurSel(0);
	OldGroup = 0;

	// Change the position of the slider controls to match the colors for the new group
	SetSliderPositions();

	// Change the text next to the sliders
	SetSliderValueText();

	return TRUE;  
}


/* ********************************* */
/* Paint handler                     */
/* ********************************* */
void CPeriodicTableDlg::OnPaint() 
{
	CPaintDC dc(this); 

	if (IsIconic())
	{
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		Table.Draw(&dc, m_GroupList.GetCurSel());
		CDialog::OnPaint();
	}
}


/* ********************************* */
/* Icon dragging                     */
/* ********************************* */
HCURSOR CPeriodicTableDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


/* ********************************* */
/* Right-click handler               */
/* ********************************* */
void CPeriodicTableDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
	int e;

	e = Table.FindElement(point);
	if(e > -1)   // -1 will be returned if click was not on an element
	{
		if(m_ElementList.FindString(-1, Table.GetElementName(e)) == LB_ERR)
			m_ElementList.AddString(Table.GetElementName(e));
	}
	
	CDialog::OnRButtonDown(nFlags, point);
}


/* ********************************* */
/* Left-click handler                */
/* ********************************* */
void CPeriodicTableDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	int e;

	e = Table.FindElement(point);
	if(e > -1)   // -1 will be returned if click was not on an element
	{
		m_GroupList.SetCurSel(atoi(Table.GetGroup(e)));
		
		// Build the update region
		Table.BuildUpdateRegion(this, m_GroupList.GetCurSel(), OldGroup);
		UpdateWindow();

		OldGroup = m_GroupList.GetCurSel();

		SetSliderPositions();
		SetSliderValueText();
	}
	
	CDialog::OnRButtonDown(nFlags, point);
}


/* ********************************* */
/* Double-click handler              */
/* ********************************* */
void CPeriodicTableDlg::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	cElementDetails dlg;
	int             e;

	e = Table.FindElement(point);
	if(e > -1)   // -1 will be returned if click was not on an element
	{
		dlg.CurrentElement = Table.GetElement(e);
		dlg.DoModal();
	}
	
	CDialog::OnLButtonDblClk(nFlags, point);
}


/* ********************************* */
/* Show the Choose Font CommDlg      */
/* ********************************* */
void CPeriodicTableDlg::OnSetFont() 
{
	CFontDialog fdlg;
	if(fdlg.DoModal() == IDOK)
	{
		Table.SetFontFace(fdlg.GetFaceName());
		Table.SetFontSize(fdlg.GetSize());
		InvalidateRect(NULL, TRUE);
		UpdateWindow();
	}
}


/* ********************************* */
/* Group selection change handler    */
/* ********************************* */
void CPeriodicTableDlg::OnSelchangeGroupList() 
{
	SetSliderPositions();
	SetSliderValueText();

	// Build the update region
	Table.BuildUpdateRegion(this, m_GroupList.GetCurSel(), OldGroup);

	OldGroup = m_GroupList.GetCurSel();

	UpdateWindow();
}


/* ********************************* */
/* Clear the element listbox         */
/* ********************************* */
void CPeriodicTableDlg::OnClearList() 
{
	m_ElementList.ResetContent();
}


/* ********************************* */
/* Handle Slider control             */
/* ********************************* */
void CPeriodicTableDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// if the scroll message comes from any of our slider controls...
	if((pScrollBar == (CScrollBar*)&m_SliderRed) || (pScrollBar == (CScrollBar*)&m_SliderGreen) || (pScrollBar == (CScrollBar*)&m_SliderBlue))
	{
		// get it's position and update the values in the Table object 
		Table.SetGroupBGColor(m_GroupList.GetCurSel(), RGB(m_SliderRed.GetPos(), m_SliderGreen.GetPos(), m_SliderBlue.GetPos()));
		// draw the new numeric values next to the sliders
		SetSliderValueText();
		
		// Build the update region
		Table.BuildUpdateRegion(this, m_GroupList.GetCurSel());

		// force the window to redraw
		UpdateWindow();
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}


/* ********************************* */
/* Show the value of the slider      */
/* ********************************* */
void CPeriodicTableDlg::SetSliderValueText()
{
	CString ColorValueText;

	ColorValueText.Format("%d", m_SliderRed.GetPos());
	m_RValue.SetWindowText(ColorValueText);
	ColorValueText.Format("%d", m_SliderGreen.GetPos());
	m_GValue.SetWindowText(ColorValueText);
	ColorValueText.Format("%d", m_SliderBlue.GetPos());
	m_BValue.SetWindowText(ColorValueText);
}


/* ********************************* */
/* Set the slider positions          */
/* ********************************* */
void CPeriodicTableDlg::SetSliderPositions()
{
	m_SliderRed.SetPos(GetRValue(Table.GetGroupBGColor(m_GroupList.GetCurSel())));
	m_SliderGreen.SetPos(GetGValue(Table.GetGroupBGColor(m_GroupList.GetCurSel())));
	m_SliderBlue.SetPos(GetBValue(Table.GetGroupBGColor(m_GroupList.GetCurSel())));
}


/* ********************************* */
/* Handle window resize              */
/* ********************************* */
void CPeriodicTableDlg::OnSize(UINT nType, int cx, int cy) 
{
	Table.SetCellWidth(cx / 18);
	Table.BuildElementRects();
	PositionListControls(cx, cy);
	PositionSettingsControls(cx, cy);
		
	InvalidateRect(NULL, TRUE);
	UpdateWindow();
	
	CDialog::OnSize(nType, cx, cy);
}


/* ********************************* */
/* Handle window resize              */
/* ********************************* */
void CPeriodicTableDlg::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	CDialog::OnGetMinMaxInfo(lpMMI);

	lpMMI->ptMinTrackSize.x = 571;
	lpMMI->ptMinTrackSize.y = 331;
}
	

/* ********************************* */
/* OnSizing handler                  */
/* ********************************* */
void CPeriodicTableDlg::OnSizing(UINT nSide, LPRECT lpRect) 
{
	CDialog::OnSizing(nSide, lpRect);

	
}


/* ********************************* */
/* Reposition the list controls      */
/* ********************************* */
void CPeriodicTableDlg::PositionListControls(int cx, int cy) 
{
	int Width         =  Table.GetCellWidth() * 2;
	int ListBoxY      =  Table.GetCellWidth() * 7;
	int ButtonHeight  =  Table.GetCellWidth()/3;
	int ListBoxHeight = (Table.GetCellWidth() * 2) - ButtonHeight;
	int ButtonY       =  ListBoxY + ListBoxHeight;
	
	if((m_ElementList.GetSafeHwnd() != NULL) && (m_ClearButton.GetSafeHwnd() != NULL))
	{
		m_ElementList.MoveWindow(0, ListBoxY, Width, ListBoxHeight, TRUE);
		m_ClearButton.MoveWindow(0, ButtonY,  Width, ButtonHeight,  TRUE);
	}
}


/* ********************************* */
/* Reposition the settings controls  */
/* ********************************* */
void CPeriodicTableDlg::PositionSettingsControls(int cx, int cy)
{
	CRect r;
	CRect rr;

	if(!m_SettingsFrame.GetSafeHwnd())
		return;

	m_SettingsFrame.MoveWindow(Table.GetCellWidth() * 3, 0, Table.GetCellWidth() * 8, Table.GetCellWidth() * 3, TRUE);

	// Get the coords for the frame - all other positions will be relative to this window
	m_SettingsFrame.GetWindowRect(&r);
	// Convert the screen coordinates to the main window's client area coordinates
	ScreenToClient(&r);

	// define the proportions
	int spacer = r.Height() / 8;
	int one_third_horz = r.Width()/3;
	int one_third_vert = r.Height()/3;

	// reposition the left side controls
	m_SelectGroup.MoveWindow(r.left + spacer, r.top + spacer,                        (r.Width()/3) - spacer, (r.Height()/3) - spacer, TRUE);
	m_GroupList.MoveWindow  (r.left + spacer, r.top + (r.Height()/4) + spacer,       (r.Width()/3) - spacer, 150, TRUE);
	m_SetFont.MoveWindow    (r.left + spacer, r.top + ((r.Height()/4) * 2) + spacer, (r.Width()/3) - spacer, (r.Height()/3) - spacer, TRUE);

	// reposition the right side controls
	m_DragSliders.MoveWindow(((r.Width()/3) * 2) + (spacer * 2), r.top + spacer, ((r.Width()/3) * 2) - spacer, (r.Height()/4) - spacer);
	
	// position the R-G-B first
	m_R.MoveWindow(((r.Width()/3) * 2) + spacer + 3, r.top + (r.Height()/5) + spacer, spacer, (r.Height()/4) - spacer);
	m_R.GetWindowRect(&rr);
	ScreenToClient(&rr);
	m_SliderRed.MoveWindow(rr.left + rr.Width(), rr.top, r.Width()/2, rr.Height());
	m_SliderRed.GetWindowRect(&rr);
	ScreenToClient(&rr);
	m_RValue.MoveWindow(rr.left + rr.Width(), rr.top, spacer * 2, rr.Height());

	m_G.MoveWindow(((r.Width()/3) * 2) + spacer + 3, r.top + ((r.Height()/5) * 2) + spacer, spacer, (r.Height()/4) - spacer);
	m_G.GetWindowRect(&rr);
	ScreenToClient(&rr);
	m_SliderGreen.MoveWindow(rr.left + rr.Width(), rr.top, r.Width()/2, rr.Height());
	m_SliderGreen.GetWindowRect(&rr);
	ScreenToClient(&rr);
	m_GValue.MoveWindow(rr.left + rr.Width(), rr.top, spacer * 2, rr.Height());

	m_B.MoveWindow(((r.Width()/3) * 2) + spacer + 3, r.top + ((r.Height()/5) * 3) + spacer, spacer, (r.Height()/4) - spacer);
	m_B.GetWindowRect(&rr);
	ScreenToClient(&rr);
	m_SliderBlue.MoveWindow(rr.left + rr.Width(), rr.top, r.Width()/2, rr.Height());
	m_SliderBlue.GetWindowRect(&rr);
	ScreenToClient(&rr);
	m_BValue.MoveWindow(rr.left + rr.Width(), rr.top, spacer * 2, rr.Height());
}


/* ********************************* */
/* About box                         */
/* ********************************* */
void CPeriodicTableDlg::OnHelpAbout() 
{
	cAbout dlg;
	dlg.DoModal();
}


/* ********************************* */
/* Exit App                          */
/* ********************************* */
void CPeriodicTableDlg::OnFileExit() 
{
	EndDialog(TRUE);
}

